#include<bits/stdc++.h>
#define pii pair<int, int>
#define INF INT_MAX
using namespace std;

int N, M, brV, brR;

vector <vector<pii>> G;
vector <bool> used;
vector <int> d;
priority_queue <pii, vector<pii>, greater<pii>> pq;
vector <int> vis;

void Alg(int s)
{
    d.resize(brV, INF);
    d[s] = 0;
    used.resize(brV, false);
    pq.push({0, s});

    while(!pq.empty())
    {
        s = pq.top().second;
        pq.pop();

        if(used[s])continue;
        used[s] = true;

        for(auto v : G[s])
        {
            if(!used[v.second] && d[v.second] > d[s] + v.first)
            {
                d[v.second] = d[s] + v.first;
                pq.push({d[v.second], v.second});
            }
        }
    }
}


int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);



    cin >> brV >> M;

    vis.resize(brV);
    for(int i=0; i<brV; i++)
    {
        cin >> vis[i];
    }

    G.resize(brV);

    for(int i=0; i<M; i++)
    {
        int z, y;
        cin >> z >> y;
        G[z-1].push_back({0, y-1});
        G[y-1].push_back({0, z-1});
    }

    for(int i=0; i<brV; i++)
    {
        for(int j=0; j<brV; j++)
        {
            G[i].push_back({abs(vis[i]-vis[j]), j});
            G[j].push_back({abs(vis[i]-vis[j]), i});
        }
    }

    Alg(0);
    cout << d[brV-1] << endl;

    return 0;
}
