#include <bits/stdc++.h>
using namespace std;
typedef signed long long ull;

const ull MAXN = 100007;
const ull MAXM = 100007;

vector<ull> G1[MAXN];
ull c[MAXN];
ull component[MAXN];
vector<ull> comps[MAXN];
//vector<pair<ull, ull>> G2[MAXN];
ull n, m;
ull k = 0;

void dfs_comps(ull curr, ull comp){
    comps[comp].push_back(c[curr]);
    component[curr] = comp;
    for(ull i = 0; i < G1[curr].size(); i++){
        if(component[G1[curr][i]] == 0){
            dfs_comps(G1[curr][i], comp);
        }
    }
}

ull dist(ull a, ull b){
    ull diff = a-b;
    if(diff >= 0){return diff;}
    return -diff;
}

ull dist(const vector<ull>& a, const vector<ull>& b){
    ull minD = INT_MAX;

    ull ai = 0, bi = 0;
    ull last = -1;
    bool lastFromB = false;
    while((ai != a.size()) || (bi != b.size())){
        ull curr;
        bool currFromB;
        if(ai != a.size() && bi != b.size()){
            if(a[ai] < b[bi]){
                curr = a[ai];
                ai++;
                currFromB = false;
            }else{
                curr = b[bi];
                bi++;
                currFromB = true;
            }
        }else if(ai == a.size()){
            curr = b[bi];
            bi++;
            currFromB = true;
        }else if(bi == b.size()){
            curr = a[ai];
            ai++;
            currFromB = false;
        }else{
            cerr << "PANIKA!!!\n";
        }


//        cout << "\t" << curr << " " << (currFromB?"b\n":"a\n");
        if(currFromB != lastFromB && last != -1){
            ull d = dist(last, curr);
//            cout << "\t\td = " << d << '\n';
            minD = min(d, minD);
        }

        last = curr;
        lastFromB = currFromB;
    }
    return minD;
}

int main(){
    /**
      *    ZAGUBI IGRATA
      */
    cin >> n >> m;
    for(ull i = 0; i < n; i++){
        cin >> c[i];
    }
    for(ull i = 0; i < m; i++){
        ull u, v;
        cin >> u >> v;
        u--; v--;
        G1[u].push_back(v);
        G1[v].push_back(u);
    }

    /// namirane na svurzani komponenti
    for(ull i = 0; i < n; i++){
        if(component[i] == 0){
            dfs_comps(i, ++k);
        }
    }


    for(ull i = 1; i <= k; i++){
        sort(comps[i].begin(), comps[i].end());
//        cout << "sorted: ";
//        for(ull el : comps[i]){
//            cout << el << ' ';
//        }cout << '\n';
    }

    vector<ull> ds;

    for(ull i = 1; i <= k; i++){
        for(ull j = i+1; j <= k; j++){
            ull d = dist(comps[i], comps[j]);
//            cout << "dist between C#" << i << " and C#" << j << " is " << d << '\n';
//            G2[i].push_back({j, d});
//            G2[j].push_back({i, d});
            ds.push_back(d);
        }
    }

    sort(ds.begin(), ds.end());
    ull sum = 0;
    for(ull i = 0; i < k-1; i++){
        sum += ds[i];
    }

    cout << sum << '\n';
    return 0;
}
