#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1000007;

int n, m;
int squad1[MAXN], squad2[MAXN];

int dist(const int* a, int n){
    int minD = INT_MAX;
    for(int i = 0; i < m; i++){
        minD = min(minD, abs(a[i]-n));
    }
    return minD;
}

int dist(const int* a, const int* b, int& bCLosest){
    int minD = INT_MAX;

    int ai = 0, bi = 0;
    int last = -1;
    bool lastFromB = false;
    while((ai != m) || (bi != m)){
        int curr;
        bool currFromB;
        if(ai != m && bi != m){
            if(a[ai] < b[bi]){
                curr = a[ai];
                ai++;
                currFromB = false;
            }else{
                curr = b[bi];
                bi++;
                currFromB = true;
            }
        }else if(ai == m){
            curr = b[bi];
            bi = m;
            currFromB = true;
        }else if(bi == m){
            curr = a[ai];
            ai = m;
            currFromB = false;
        }else{
            cerr << "PANIKA!!!\n";
        }


//        cout << "\t" << curr << " " << (currFromB?"b\n":"a\n");
        if(currFromB != lastFromB && last != -1){
            int d = abs(last-curr);
//            cout << "\t\td = " << d << '\n';
            if(d < minD){
                minD = d;
                bCLosest = (currFromB?curr:last);
            }
        }

        last = curr;
        lastFromB = currFromB;
    }
    return minD;
}

int main(){
    cin >> n >> m;

    int sq2Closest;
    int mx = INT_MIN;
    {
        for(int j = 0; j < m; j++){
            cin >> squad1[j];
        }
        sort(squad1, squad1+m);
        for(int j = 0; j < m; j++){
            cin >> squad2[j];
        }
        sort(squad2, squad2+m);
        int d = dist(squad1, squad2, sq2Closest);
        mx = max(mx, d);
        swap(squad1, squad2);
    }

    for(int i = 2; i < n; i++){
        for(int j = 0; j < m; j++){
            cin >> squad2[j];
        }
        sort(squad2, squad2+m);
        int d = dist(squad2, sq2Closest);
//        cout << ""
//        cout << "diff(" << i-1 << "," << i << "): " << d << '\n';
        mx = max(mx, d);
        swap(squad1, squad2);
    }

    cout << mx << '\n';
    return 0;
}
