#include<bits/stdc++.h>
using namespace std;
const int maxn=100003;
int vis[maxn];
bool used[maxn];
vector<int> edges[maxn];
vector<int> v;
void bfs(int s){
    queue<int> q;
    q.push(s);
    used[s]=true;
    while(!q.empty()){
        int u=q.front();
        q.pop();
        for(auto v1: edges[u]){
            if(!used[v1]){
                used[v1]=true;
                q.push(v1);
            }
        }
    }

}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin>>n>>m;
    for(int i=1;i<=n;i++) cin>>vis[i];
    for(int i=0;i<m;i++){
        int u, v;
        cin>>u>>v;
        edges[u].push_back(v);
        edges[v].push_back(u);
    }

    for(int i=1;i<=n;i++){
        if(used[i]) continue;
        bfs(i);
        v.push_back(i);
    }
    sort(v.begin(), v.end());
    int num=0;
    for(int i=1;i<v.size();i++){
        num+=v[i]-v[i-1];
    }
    cout<<num;
    return 0;
}
