#include <iostream>
#include <algorithm>

using namespace std;

#define MAX_SIZE 5000000

long long positions[MAX_SIZE];

int currentPos = 2;
int rem = 0;

int getNumber(int pos)
{
    int index = distance(positions, upper_bound(positions, positions + MAX_SIZE, pos));
    return index - 1;
}

int main()
{
    positions[0] = 0;
    positions[1] = 0;
    positions[2] = 1;

    for (int i = 3; i < MAX_SIZE; i++)
    {
        positions[i] = positions[i - 1] + currentPos; rem++;
        //cout << i << " - " << positions[i] << endl;

        if ((positions[currentPos + 1] - positions[currentPos]) == rem)
        {
            currentPos++;
            rem = 0;
        }
    }

    int N; cin >> N; N--;

    cout << getNumber(N);
}
