#include <iostream>
#include <algorithm>
#include <math.h>

using namespace std;

#define A(i, j) Arr[i + j * N]
#define ptr(row) Arr + row * N
#define MAX_N 10000000

int Arr[MAX_N];
int N, M;

int diff(int element)
{
    int maxDiff = 0;
    int currentDiff = 0;

    for (int row = 0; row < M; row++)
    {
        currentDiff = MAX_N;
        if (element >= A(N - 1, row)) return MAX_N;
        for (int i = 0; i < N; i++)
        {
            currentDiff = min(currentDiff, abs(element - A(i, row)));
        }
        maxDiff = max(maxDiff, currentDiff);
    }

    return maxDiff;
}

int main()
{
    cin >> M >> N;

    for (int y = 0; y < M; y++)
    {
        for (int x = 0; x < N; x++)
        {
            ///cin >> A[x][y];
            cin >> A(x, y);
        }
    }

    for (int i = 0; i < M; i++)
    {
        sort (ptr(i), ptr(i) + N);
    }

    for (int y = 0; y < M; y++)
    {
        for (int x = 0; x < N; x++)
        {
            ///cout << A(x, y) << ", ";
        }
        ///cout << endl;
    }

    ///cout << endl;

    int answer = MAX_N;

    for (int y = 0; y < M; y++)
    {
        for (int x = 0; x < N; x++)
        {
            answer = min(answer, diff(A(x, y)));
            ///cout << diff(A(x, y)) << ", ";
        }
        ///cout << endl;
    }

    cout << answer;
}

