#include <bits/stdc++.h>

using namespace std;

const int inf = 1000000000;

int n, m;

vector<vector<int>> a;

vector<vector<int>> dp;

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m;

    a.resize(n);

    dp.resize(n);

    for (int i = 0; i < m; ++i)
    {
        dp[0].push_back(0);
    }

    for (int i = 1; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            dp[i].push_back(inf);
        }
    }

    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            int x;
            cin >> x;
            a[i].push_back(x);
        }
    }

    if (n == 1)
    {
        cout << 0 << endl;
        return 0;
    }

    for (int i = 0; i < n; ++i)
    {
        sort(a[i].begin(), a[i].end());

        vector<int> newv;

        for (int j = 0; j < m; ++j)
        {
            if (j == 0 || a[i][j] != a[i][j - 1])
            {
                newv.push_back(a[i][j]);
            }
        }

        a[i] = newv;
    }

    for (int i = 1; i < n; ++i)
    {
        for (int j = 0; j < a[i].size(); ++j)
        {
            int l = 0;
            int r = a[i - 1].size();

            while (l <= r)
            {
                int mid = (l + r) / 2;

                if (a[i - 1][mid] >= a[i][j])
                {
                    r = mid - 1;
                }
                else
                {
                    l = mid + 1;
                }
            }

            int from = max(0, l - 300);
            int to = min(int(a[i].size()) - 1, l + 300);

            for (int k = from; k <= to; ++k)
            {
                dp[i][j] = min(dp[i][j], max(abs(a[i][j] - a[i - 1][k]), dp[i - 1][k]));
            }
        }
    }

    int ans = inf;

    for (int i = 0; i < m; ++i)
    {
        ans = min(ans, dp[n - 1][i]);
    }

    cout << ans << endl;

    return 0;
}
