#include<bits/stdc++.h>
using namespace std;

#define endl "\n"

const long long MAX_N = 1e5 + 5;

int n, m;
int c[MAX_N];
vector <int> susediNa[MAX_N];

vector <int> comp[MAX_N];
int componenta[MAX_N];
int compCount = 0;

void bfs (int start, int cmp) {
    comp[cmp].push_back(start);
    queue <int> current;
    current.push(start);
    componenta[start] = cmp;

    while (!current.empty()) {
        int curr = current.front();
        current.pop();
        for (int i = 0; i < susediNa[curr].size(); i ++) {
            if (componenta[susediNa[curr][i]] != -1) continue;
            current.push(susediNa[curr][i]);
            componenta[susediNa[curr][i]] = cmp;
            comp[cmp].push_back(susediNa[curr][i]);
        }
    }
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    for (int i = 0; i < MAX_N; i ++) {
        componenta[i] = -1;
    }

    cin >> n >> m;

    for (int i = 0; i < n; i ++) {
        cin >> c[i];
    }

    for (int i = 0; i < m; i ++) {
        int a, b;
        cin >> a >> b;
        a --;
        b --;
        susediNa[a].push_back(b);
        susediNa[b].push_back(a);
    }

    for (int i = 0; i < n; i ++) {
        if (componenta[i] != -1) continue;

        bfs(i, compCount);
        compCount ++;
    }
    /*
    for (int i = 0; i < n; i ++) {
        cout << i << " - " << componenta[i] << endl;
    }

    for (int i = 0; i < compCount; i ++) {
        cout << i << ". ";
        for (int j = 0; j < comp[i].size(); j ++) {
            cout << comp[i][j] << " ";
        }
        cout << endl;
    }
*/
    long long ans = 0;
    for (int i = 0; i < n - 1; i ++) {
        if (componenta[i] != componenta[i + 1]) {
            ans ++;
            //cout << i << " " << i + 1 << " " << componenta[i] << " " << componenta[i + 1] << endl;
            for (int j = 0; j < comp[componenta[i + 1]].size(); j ++) {
                //cout << "\t" << componenta[i + 1] << " " << comp[componenta[i + 1]].size() << " " << comp[componenta[i + 1]][j] << " -> " << componenta[i] << endl;
                if (comp[componenta[i + 1]][j] != i + 1) componenta[comp[componenta[i + 1]][j]] = componenta[i];
            }
        }
        componenta[i + 1] = componenta[i];
    }

    cout << ans << endl;
    return 0;
}
