#include<bits/stdc++.h>
using namespace std;
#define endl "\n"

const long long MAX_N = 1e6 + 10;
const long long INF = 1e8 + 10;

int n, m;
int a[2][MAX_N];
int answers[2][MAX_N];

bool isIn (int i) {
    return i >= 0 && i < m;
}

int binary (int row, int x) {
    int l = 0, r = m - 1, mid = (l + r) / 2;
    int ans = -1;
    while (l <= r) {
        mid = (l + r) / 2;
        if (a[row][mid] <= x) {
            ans = mid;
            l = mid + 1;
        } else {
            r = mid - 1;
        }
    }
    return ans;
}



int solve (int row, int col, int ans) {
    if (row == n - 1) return ans;
    int ind = binary(row + 1, a[row][col]);
    cout << row << " " << col << " binary(" << row + 1 << ", " << a[row][col] << ") = " << ind << endl;
    int closest = INF, clInd = 0;
    if (isIn(ind)) {
        if(closest > abs(a[row][col] - a[row + 1][ind])) {
            clInd = ind;
            closest = abs(a[row][col] - a[row + 1][ind]);
        }
    }
    if (isIn(ind + 1)) {
        if (closest > abs(a[row][col] - a[row + 1][ind + 1])) {
            closest = abs(a[row][col] - a[row + 1][ind + 1]);
            clInd = ind + 1;
        }
    }
    return solve(row + 1, clInd, max(closest, ans));
}
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> m;

    for (int i = 0; i < n; i ++) {
        for (int j = 0; j < m; j ++) {
            cin >> a[i % 2][j];

            ///a[i % 2][j] /= 10000;

            answers[i % 2][j] = INF;
        }
        sort (a[i % 2], a[i % 2] + m);
        if (i == 0) continue;
        /*
        cout << endl;
        cout << endl;
        cout << i << ": " << endl;
        for (int row = 0; row < 2; row ++) {
            for (int col = 0; col < m; col ++) {
                cout << a[row][col] << " ";
            }
            cout << endl;
        }
        */
        if (i % 2 == 0) {
            for (int col = 0; col < m; col ++) {
                int ind = binary(0, a[1][col]);
                //cout << " binary(" << 1 << ", " << a[1][col] << ") = " << ind << endl;
                int closest = INF, clInd = 0;
                if (isIn(ind)) {
                    if(closest > abs(a[1][col] - a[0][ind])) {
                        clInd = ind;
                        closest = abs(a[1][col] - a[0][ind]);
                    }
                }
                if (isIn(ind + 1)) {
                    if (closest > abs(a[1][col] - a[0][ind + 1])) {
                        closest = abs(a[1][col] - a[0][ind + 1]);
                        clInd = ind + 1;
                    }
                }
                int right = closest;
                if (answers[0][col] != INF) right = max(right, answers[0][col]);
                answers[1][clInd] = min(answers[1][col], right);
            }
        }

        if (i % 2 == 1) {
            for (int col = 0; col < m; col ++) {
                int ind = binary(1, a[0][col]);
                int closest = INF, clInd = 0;
                if (isIn(ind)) {
                    if(closest > abs(a[0][col] - a[1][ind])) {
                        clInd = ind;
                        closest = abs(a[0][col] - a[1][ind]);
                    }
                }
                if (isIn(ind + 1)) {
                    if (closest > abs(a[0][col] - a[1][ind + 1])) {
                        closest = abs(a[0][col] - a[1][ind + 1]);
                        clInd = ind + 1;
                    }
                }
                int right = closest;
                if (answers[1][col] != INF) right = max(right, answers[1][col]);
                answers[0][clInd] = min(answers[0][col], right);
            }
        }

        /*
        cout << endl;
        cout << endl;
        for (int row = 0; row < 2; row ++) {
            for (int col = 0; col < m; col ++) {
                cout << answers[row][col] << " ";
            }
            cout << endl;
        }
        cout << endl;
        */
    }

    /*
    cout << endl;
    for (int i = 0; i < n ; i ++) {
        for  (int j = 0; j < m ; j ++) {
            cout << a[i][j] << " ";
        }

        cout << endl;
    }
    cout << endl;
    */
    int ans = answers[n % 2][0];
    for (int i = 0; i < m; i ++) {
        ans = min(answers[n % 2][i], ans);
    }

    cout << ans << endl;


    return 0;
}

