#include<bits/stdc++.h>
using namespace std;
#define endl "\n"

const long long MAX_N = 1e6 + 10;
const long long INF = 1e8 + 10;

long long n, m;
long long a[2][MAX_N];
long long answers[2][MAX_N];

bool isIn (long long i) {
    return i >= 0 && i < m;
}

long long binary (long long row, long long x) {
    long long l = 0, r = m - 1, mid = (l + r) / 2;
    long long ans = -1;
    while (l <= r) {
        mid = (l + r) / 2;
        if (a[row][mid] <= x) {
            ans = mid;
            l = mid + 1;
        } else {
            r = mid - 1;
        }
    }
    return ans;
}



int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> m;

    for (long long i = 0; i < n; i ++) {
        for (long long j = 0; j < m; j ++) {
            cin >> a[i % 2][j];

            answers[i % 2][j] = INF;
        }
        sort (a[i % 2], a[i % 2] + m);
        if (i == 0) continue;
        if (i % 2 == 0) {
            for (long long col = 0; col < m; col ++) {
                long long ind = binary(0, a[1][col]);
                long long closest = INF, clInd = 0;
                if (isIn(ind)) {
                    if(closest > abs(a[1][col] - a[0][ind])) {
                        clInd = ind;
                        closest = abs(a[1][col] - a[0][ind]);
                    }
                }
                if (isIn(ind + 1)) {
                    if (closest > abs(a[1][col] - a[0][ind + 1])) {
                        closest = abs(a[1][col] - a[0][ind + 1]);
                        clInd = ind + 1;
                    }
                }
                long long right = closest;
                if (answers[0][col] != INF) right = max(right, answers[0][col]);
                answers[1][clInd] = min(answers[1][col], right);
            }
        }

        if (i % 2 == 1) {
            for (long long col = 0; col < m; col ++) {
                long long ind = binary(1, a[0][col]);
                long long closest = INF, clInd = 0;
                if (isIn(ind)) {
                    if(closest > abs(a[0][col] - a[1][ind])) {
                        clInd = ind;
                        closest = abs(a[0][col] - a[1][ind]);
                    }
                }
                if (isIn(ind + 1)) {
                    if (closest > abs(a[0][col] - a[1][ind + 1])) {
                        closest = abs(a[0][col] - a[1][ind + 1]);
                        clInd = ind + 1;
                    }
                }
                long long right = closest;
                if (answers[1][col] != INF) right = max(right, answers[1][col]);
                answers[0][clInd] = min(answers[0][col], right);
            }
        }

        /*
        cout << endl;
        cout << endl;
        for (long long row = 0; row < 2; row ++) {
            for (long long col = 0; col < m; col ++) {
                cout << answers[row][col] << " ";
            }
            cout << endl;
        }
        cout << endl;
        */
    }

    /*
    cout << endl;
    for (long long i = 0; i < n ; i ++) {
        for  (long long j = 0; j < m ; j ++) {
            cout << a[i][j] << " ";
        }

        cout << endl;
    }
    cout << endl;
    */
    long long ans = answers[n % 2][0];
    for (long long i = 0; i < m; i ++) {
        ans = min(answers[n % 2][i], ans);
    }

    cout << ans << endl;


    return 0;
}

