#include<bits/stdc++.h>
#define endl "\n"
using namespace std;
vector<long long> g[100010];
vector<long long> components[100010];
vector<long long> cg[100010];
struct rib{
    long long u,v,w;
};
bool cmp(rib A,rib B){
    return A.w<B.w;
}
vector<rib> ribs;
long long a[100010];
bool visited[100010];
void dfs(long long u,long long component){
    visited[u]=true;
    components[component].push_back(a[u]);
    for(auto v: g[u]){
        if(!visited[v]) dfs(v,component);
    }
}
bool dfs2(long long u,long long V){
    for(auto v: cg[u]){
        if(v==V) return true;
        if(!visited[v]){
            visited[v]=true;
            if(dfs2(v,V)) return true;
            visited[v]=false;
        }
    }
    return false;
}
int main(){
    ios_base:: sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long n,m;
    cin>>n>>m;
    for(long long i=0;i<n;i++){
        cin>>a[i];
    }
    for(long long i=0;i<m;i++){
        long long u,v;
        cin>>u>>v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    long long comps=0;
    for(long long i=0;i<n;i++){
        if(!visited[i]){
            dfs(i,comps);
            sort(components[comps].begin(),components[comps].end());
            comps++;
        }
    }
    for(long long i=0;i<comps;i++){
        for(long long j=i+1;j<comps;j++){
            long long minDiff=1e9;
            long long marker1=0,marker2=0;
            while(marker1<components[i].size() && marker2<components[j].size()){
                minDiff=min(minDiff,abs(components[i][marker1]-components[j][marker2]));
                if(components[i][marker1]<components[j][marker2]) marker1++;
                else marker2++;
            }
            ribs.push_back({i,j,minDiff});
        }
        visited[i]=false;
    }
    sort(ribs.begin(),ribs.end(),cmp);
    long long bridges=0,cost=0;
    for(long long i=0;i<ribs.size() && bridges<comps-1;i++){
        if(!dfs2(ribs[i].u,ribs[i].v)){
            cost+=ribs[i].w;
            bridges++;
            cg[ribs[i].u].push_back(ribs[i].v);
            cg[ribs[i].v].push_back(ribs[i].u);
        }
    }
    cout<<cost;
    return 0;
}
