#include <bits/stdc++.h>
using namespace std;

const int MAX_N=1e6+1, INF=1e9;
int N, M;
vector<vector<int>> a, dp;

int bs_small(int i, int x)
{
    int l=0, r=M-1;
    int m;
    int ans=-1;

    while(l<=r)
    {
        m=(l+r)/2;

        if(a[i][m]<=x)
        {
            ans=m;
            l=m+1;
        }
        else
        {
            r=m-1;
        }
    }

    return ans;
}

int bs_big(int i, int x)
{
    int l=0, r=M-1;
    int m;
    int ans=-1;

    while(l<=r)
    {
        m=(l+r)/2;

        if(a[i][m]>=x)
        {
            ans=m;
            r=m-1;
        }
        else
        {
            l=m+1;
        }
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> N >> M;

    for(int i=0; i<N; i++)
    {
        vector<int> curr(M), empt(M);

        for(int j=0; j<M; j++)
        {
            cin >> curr[j];
            empt[j]=INF;
        }

        sort(curr.begin(), curr.end());
        a.push_back(curr);
        dp.push_back(empt);
    }


    for(int i=0; i<N; i++)
    {
        for(int j=0; j<M; j++)
        {
            ////cout << a[i][j] << " ";

            if(i==0)
            {
                dp[i][j]=0;
            }
            else
            {
                int l=bs_small(i-1, a[i][j]), r=bs_big(i-1, a[i][j]);
                int st;

                if(l!=-1)
                {
                    st=max(abs(a[i][j]-a[i-1][l]), dp[i-1][l]);
                    dp[i][j]=min(st, dp[i][j]);
                }

                if(r!=-1)
                {
                    st=max(abs(a[i][j]-a[i-1][r]), dp[i-1][r]);
                    dp[i][j]=min(st, dp[i][j]);
                }
            }
        }

        ///cout << '\n';
    }


    int ans=INF;


    for(int i=0; i<M; i++)
    {
        ans=min(ans, dp[N-1][i]);
    }

    cout << ans;

    return 0;
}

