# include <iostream>
# include <vector>
using namespace std;

const long long INF=1e15+1;
vector<vector<long long>> a;
vector<vector<long long>> dp;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    long long n,m;
    cin>>n>>m;
    a.resize(n+1);
    for(int i=1;i<=n;i++)
    {
        a[i].resize(m+1);
        for(int j=1;j<=m;j++)
        {
            cin>>a[i][j];
        }
    }

    dp.resize(n+1);
    for(int i=1;i<=n;i++)
    {
        dp[i].resize(m+1);
        for(int j=1;j<=m;j++)
        {
            dp[i][j]=INF;
        }
    }

    for(int i=1;i<=m;i++)
    {
        dp[1][i]=0LL;
    }

    for(int i=2;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            for(int k=1;k<=m;k++)
            {
                dp[i][j]=min(dp[i][j],max(dp[i-1][k],abs(a[i][j]-a[i-1][k])));
            }
            //cout<<i<<" "<<j<<":"<<dp[i][j]<<endl;
        }
    }

    long long ans=INF;
    for(int i=1;i<=m;i++)
    {
        ans=min(ans,dp[n][i]);
    }

    cout<<ans<<endl;
    return 0;
}
