# include <iostream>
# include <vector>
using namespace std;

const long long INF=1e15+1;
vector<vector<long long>> a;
vector<vector<long long>> vis;
long long tm=0;
bool pos=0;
long long n,m;

void dfs(int x, int y, int d)
{
    if(pos) return;
    if(vis[x][y]==tm) return ;
    if(x==n)
    {
        pos=1;
        return ;
    }

    vis[x][y]=tm;
    for(int i=1;i<=m;i++)
    {
        if(abs(a[x][y]-a[x+1][i])<=d and vis[x+1][i]<tm and pos==0) dfs(x+1,i,d);
    }
}

bool can(int d)
{
    pos=0;
    tm++;
    for(int i=1;i<=m;i++)
    {
        if(pos==1) return true;
        dfs(1,i,d);
    }

    return pos;
}

void binary()
{
    long long l=0,r=1e6,ans=INF;
    while(l<=r)
    {
        long long mid=(l+r)/2;
        if(can(mid))
        {
            ans=min(ans,mid);
            r=mid-1;
        }
        else l=mid+1;
    }

    cout<<ans<<endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n>>m;
    a.resize(n+1);
    for(int i=1;i<=n;i++)
    {
        a[i].resize(m+1);
        for(int j=1;j<=m;j++)
        {
            cin>>a[i][j];
        }
    }

    vis.resize(n+1);
    for(int i=1;i<=n;i++)
    {
        vis[i].resize(m+1);
        for(int j=1;j<=m;j++)
        {
            vis[i][j]=0;
        }
    }

    binary();
    return 0;
}

