#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e6+5;
int n,m;
vector<long long>v[maxn];
long long dp[2][maxn];

void read()
{
    cin >> n >> m;
    int a;
    for(int i=1;i<=n;i++)
    {
        v[i].push_back(0);
        for(int j=1;j<=m;j++)
        {
            cin >> a;
            v[i].push_back(a);
        }
        sort(v[i].begin(),v[i].end());
    }
}

int bin_s(int i, long long x)
{
    int l = 1, r = m;
    int mid;
    while(l<=r)
    {
        mid = (l+r)/2;
        if(v[i][mid]<=x) l = mid+1;
        else r = mid-1;
    }
    return l;
}

void solve()
{
    int tek = 1, old = 1;
    for(int j=1;j<=m;j++) dp[tek][j] = 0;
    for(int i=2;i<=n;i++)
    {
        tek = i%2;
        for(int j=1;j<=m;j++)
        {
            dp[tek][j] = 1e9;
            int k = bin_s(i-1,v[i][j]);
            if(1<=k&&k<=m) dp[tek][j] = min(dp[tek][j],max(dp[old][k],abs(v[i][j]-v[i-1][k])));
            k--;
            if(1<=k&&k<=m) dp[tek][j] = min(dp[tek][j],max(dp[old][k],abs(v[i][j]-v[i-1][k])));
            k++;
            k++;
            if(1<=k&&k<=m) dp[tek][j] = min(dp[tek][j],max(dp[old][k],abs(v[i][j]-v[i-1][k])));
        }
        old = tek;
    }
    long long ans = 1e9;
    for(int j=1;j<=m;j++)
    {
        ans = min(ans,dp[tek][j]);
    }
    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
