#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e6+5;
int n,m;
vector<long long>v[maxn];
long long used[2][maxn];
int raz,chis;

void read()
{
    cin >> n >> m;
    int a;
    for(int i=1;i<=n;i++)
    {
        v[i].push_back(0);
        for(int j=1;j<=m;j++)
        {
            cin >> a;
            v[i].push_back(a);
        }
        sort(v[i].begin(),v[i].end());
    }
}

int bin_s(int i, long long x)
{
    int l = 1, r = m;
    int mid;
    while(l<=r)
    {
        mid = (l+r)/2;
        if(v[i][mid]<=x) l = mid+1;
        else r = mid-1;
    }
    return l;
}

void fill_used(int i, int pos)
{
    int next = i%2;
    for(int j=pos;j<=m&&!used[next][j]&&abs(chis-v[i][j])<=raz;j++)
    {
        used[next][j] = 1;
    }
    for(int j=pos;j>=1&&!used[next][j]&&abs(chis-v[i][j])<=raz;j--)
    {
        used[next][j] = 1;
    }
}

bool check(int x)
{
    raz = x;
    int tek = 1, next = 1;
    for(int j=1;j<=m;j++) used[tek][j] = 1;
    for(int i=1;i<n;i++)
    {
        tek = i%2;
        next = (i+1)%2;
        for(int j=1;j<=m;j++)
        {
            used[next][j] = 0;
        }
        for(int j=1;j<=m;j++)
        {
            if(!used[tek][j]) continue;
            chis = v[i][j];
            int k = bin_s(i+1,v[i][j]);
            if(1<=k&&k<=m) fill_used(i+1,k);
            k--;
            if(1<=k&&k<=m) fill_used(i+1,k);
            k++;
            k++;
            if(1<=k&&k<=m) fill_used(i+1,k);
        }
    }
    for(int j=1;j<=m;j++) if(used[next][j]) return true;
    return false;
}

void solve()
{
    int l = 0, r = 2*1e6;
    int mid;
    while(l<=r)
    {
        mid = (l+r)/2;
        if(check(mid)) r = mid-1;
        else l = mid+1;
    }
    cout << l << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
