#include<bits/stdc++.h>
using namespace std;
struct edge
{
    int x,y,d;
    edge(){}
    edge(int _x,int _y,int _d)
    {
        x=_x;
        y=_y;
        d=_d;
    }
    bool operator<(const edge e)const
    {
        return e.d<d;
    }
};
int n,m,c[100001];
vector<int> v[100001];
bool first=1;
void read()
{
    cin>>n>>m;
    for(int i=1;i<=n;i++)
    {
        cin>>c[i];
        if(c[i]!=i)first=0;
    }
    for(int i=1;i<=m;i++)
    {
        int a,b;
        cin>>a>>b;
        v[a].push_back(b);
    }
}
bool used[100001];
int cnt,comp[100001];
vector<int> h[100001];
void dfs(int i)
{
    comp[i]=cnt;
    h[cnt].push_back(c[i]);
    used[i]=1;
    for(int j=0;j<v[i].size();j++)
    {
        int nb=v[i][j];
        if(!used[nb])dfs(nb);
    }
}
void prec()
{
    for(int i=1;i<=n;i++)
    {
        if(!used[i])
        {
            cnt++;
            dfs(i);
        }
    }
    if(first)
    {
        cout<<cnt-1<<endl;
        exit(0);
    }
    for(int i=1;i<=cnt;i++)
    {
        sort(h[i].begin(),h[i].end());
    }
}
priority_queue<edge> q;
int p[100001],sz[100001],ans;
int findpar(int x)
{
    if(x==p[x])return x;
    return p[x]=findpar(p[x]);
}
void unite(int x,int y,int d)
{
    int p1=findpar(x);
    int p2=findpar(y);
    if(p1!=p2)
    {
        if(sz[p1]>sz[p2])swap(p1,p2);
        p[p1]=p2;
        sz[p2]+=sz[p1];
        ans+=d;
    }
}
void solve()
{
    for(int i=1;i<=cnt;i++)
    {
        for(int j=i+1;j<=cnt;j++)
        {
            int l=0;
            for(int k=0;k<h[i].size();k++)
            {
                while(l<h[j].size()&&h[i][k]>h[j][l])l++;
                if(l==h[j].size())
                {
                    q.push({i,j,abs(h[i][k]-h[j][h[j].size()-1])});
                    continue;
                }
                //cout<<i<<" "<<k<<" "<<j<<" "<<l<<endl;
                q.push({i,j,abs(h[i][k]-h[j][l])});
                if(l<=h[j].size())q.push({i,j,abs(h[i][k]-h[j][l-1])});
            }
        }
    }
    for(int i=1;i<=cnt;i++)
    {
        p[i]=i;
        sz[i]=1;
    }
    while(!q.empty())
    {
        edge t=q.top();
        //cout<<t.x<<" "<<t.y<<" "<<t.d<<endl;
        q.pop();
        unite(t.x,t.y,t.d);
    }
    cout<<ans<<'\n';
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    prec();
    solve();
    return 0;
}
