#include <bits/stdc++.h>

using namespace std;

const int maxn = 100005;

int n, m;

int cost[maxn];

vector<int> g[maxn];

bool visited[maxn];

void dfs(int node)
{
    visited[node] = true;

    for (auto v : g[node])
    {
        if (visited[v] == false)
        {
            dfs(v);
        }
    }
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m;

    for (int i = 1; i <= n; ++i)
    {
        cin >> cost[i];
    }

    for (int i = 0; i < m; ++i)
    {
        int x, y;
        cin >> x >> y;

        g[x].push_back(y);
        g[y].push_back(x);
    }

    int ans = 0;

    for (int i = 1; i <= n; ++i)
    {
        if (visited[i] == false)
        {
            ++ans;
            dfs(i);
        }
    }

    cout << ans - 1 << endl;

    return 0;
}
