#include <bits/stdc++.h>

using namespace std;

const int maxn = 100005;

int n, m;

int cost[maxn];

vector<int> g[maxn];

bool visited[maxn];

int cnt = 0;

vector<int> comps[maxn];

void dfs(int node)
{
    comps[cnt].push_back(cost[node]);
    visited[node] = true;

    for (auto v : g[node])
    {
        if (visited[v] == false)
        {
            dfs(v);
        }
    }
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m;

    for (int i = 1; i <= n; ++i)
    {
        cin >> cost[i];
    }

    for (int i = 0; i < m; ++i)
    {
        int x, y;
        cin >> x >> y;

        g[x].push_back(y);
        g[y].push_back(x);
    }

    for (int i = 1; i <= n; ++i)
    {
        if (visited[i] == false)
        {
            ++cnt;
            dfs(i);
            sort(comps[i].begin(), comps[i].end());
        }
    }

    vector<int> p;

    for (int i = 1; i <= cnt; ++i)
    {
        p.push_back(i);
    }

    long long ans = (1LL << 62);

    do
    {
        long long res = 0;

        for (int i = 0; i < p.size() - 1; ++i)
        {
            int curr = 1000000005;

            for (int j = 0; j < comps[p[i]].size(); ++j)
            {
                int c = comps[p[i]][j];

                int diff = 1000000005;

                auto it = lower_bound(comps[p[i + 1]].begin(), comps[p[i + 1]].end(), c);

                if (it != comps[p[i + 1]].end())
                {
                    diff = min(diff, abs(*it - c));
                }

                if (it != comps[p[i + 1]].begin())
                {
                    --it;
                    diff = min(diff, abs(*it - c));
                }

                curr = min(curr, diff);
            }

            res += curr;
        }

        ans = min(ans, res);

    } while (next_permutation(p.begin(), p.end()));

    cout << ans << endl;

    return 0;
}
