#include <bits/stdc++.h>

using namespace std;

const int maxn = 100005;
const int max_cnt = 17;
const int max_mask = (1 << 17);

int n, m;

int cost[maxn];

vector<int> g[maxn];

bool visited[maxn];

int cnt = 0;

vector<int> comps[maxn];

int precalc[20][20];

void dfs(int node)
{
    comps[cnt].push_back(cost[node]);
    visited[node] = true;

    for (auto v : g[node])
    {
        if (visited[v] == false)
        {
            dfs(v);
        }
    }
}

long long dp[max_cnt][max_mask];
bool bl[max_cnt][max_mask];

long long f(int id, int mask)
{
    if (mask == (1 << cnt) - 1)
    {
        return 0;
    }

    if (bl[id][mask] == true)
    {
        return dp[id][mask];
    }

    bl[id][mask] = true;

    long long ans = (1LL << 62);

    for (int i = 0; i < cnt; ++i)
    {
        if (id != i && ((mask & (1 << i)) == 0))
        {
            ans = min(ans, 1LL * precalc[id][i] + f(i, (mask | (1 << i))));
        }
    }

    return dp[id][mask] = ans;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m;

    for (int i = 1; i <= n; ++i)
    {
        cin >> cost[i];
    }

    for (int i = 0; i < m; ++i)
    {
        int x, y;
        cin >> x >> y;

        g[x].push_back(y);
        g[y].push_back(x);
    }

    for (int i = 1; i <= n; ++i)
    {
        if (visited[i] == false)
        {
            dfs(i);
            sort(comps[cnt].begin(), comps[cnt].end());
            ++cnt;
        }
    }

   /* for (int i = 1; i <= cnt; ++i)
    {
        cout << i << " -> ";

        for (auto c : comps[i])
        {
            cout << c << ' ';
        }

        cout << endl;
    }*/

    for (int i = 0; i < cnt; ++i)
    {
        for (int j = 0; j < cnt; ++j)
        {
            if (i == j)
            {
                continue;
            }

            /*if (i > j)
            {
                precalc[i][j] = precalc[j][i];
                continue;
            }*/

            int res = 1000000005;

            for (int k = 0; k < comps[i].size(); ++k)
            {
                int c = comps[i][k];

                //cout << "test : " << i << ' ' << c << endl;

                auto it = lower_bound(comps[j].begin(), comps[j].end(), c);

                if (it != comps[j].end())
                {
                   // cout << *it << ' ' << c << endl;
                    res = min(res, abs(*it - c));
                }

                if (it != comps[j].begin())
                {
                    --it;
                   // cout << *it << ' ' << c << endl;
                    res = min(res, abs(*it - c));
                }
            }

            precalc[i][j] = res;

            //cout << i << ' ' << j << ' ' << res << endl;
        }
    }

    long long ans = (1LL << 62);

    for (int i = 0; i < cnt; ++i)
    {
        ans = min(ans, f(i, (1 << i)));
    }

    cout << ans << endl;

    return 0;
}
