#include <bits/stdc++.h>

using namespace std;

const int inf = 1000000005;
const int maxn = 100005;
const int max_cnt = 17;
const int max_mask = (1 << 17);

int n, m;

int cost[maxn];

vector<int> g[maxn];

bool visited[maxn];

int cnt = 0;

vector<int> comps[maxn];

int precalc[20][20];

void dfs(int node)
{
    comps[cnt].push_back(cost[node]);
    visited[node] = true;

    for (auto v : g[node])
    {
        if (visited[v] == false)
        {
            dfs(v);
        }
    }
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m;

    for (int i = 1; i <= n; ++i)
    {
        cin >> cost[i];
    }

    for (int i = 0; i < m; ++i)
    {
        int x, y;
        cin >> x >> y;

        g[x].push_back(y);
        g[y].push_back(x);
    }

    for (int i = 1; i <= n; ++i)
    {
        if (visited[i] == false)
        {
            dfs(i);
            sort(comps[cnt].begin(), comps[cnt].end());
            ++cnt;
        }
    }

   /* for (int i = 1; i <= cnt; ++i)
    {
        cout << i << " -> ";

        for (auto c : comps[i])
        {
            cout << c << ' ';
        }

        cout << endl;
    }*/

    for (int i = 0; i < cnt; ++i)
    {
        for (int j = 0; j < cnt; ++j)
        {
            if (i == j)
            {
                precalc[i][j] = inf;
                continue;
            }

            if (i > j)
            {
                precalc[i][j] = inf;
                continue;
            }

            int res = 1000000005;

            for (int k = 0; k < comps[i].size(); ++k)
            {
                int c = comps[i][k];

                //cout << "test : " << i << ' ' << c << endl;

                auto it = lower_bound(comps[j].begin(), comps[j].end(), c);

                if (it != comps[j].end())
                {
                   // cout << *it << ' ' << c << endl;
                    res = min(res, abs(*it - c));
                }

                if (it != comps[j].begin())
                {
                    --it;
                   // cout << *it << ' ' << c << endl;
                    res = min(res, abs(*it - c));
                }
            }

            precalc[i][j] = res;

            //cout << i << ' ' << j << ' ' << res << endl;
        }
    }

    /*for (int i = 0; i < cnt; ++i)
    {
        for (int j = 0; j < cnt; ++j)
        {
            cout << precalc[i][j] << " ";
        }
        cout << endl;
    }*/

    priority_queue<int> pq;

    for (int i = 0; i < cnt; ++i)
    {
        for (int j = 0; j < cnt; ++j)
        {
            if (precalc[i][j] != inf)
            {
                pq.push(-precalc[i][j]);
            }
        }
    }

    long long ans = 0;

    for (int i = 1; i < cnt; ++i)
    {
        ans += (-pq.top());
        pq.pop();
    }

    cout << ans << endl;

    return 0;
}
