#include <bits/stdc++.h>

using namespace std;

const int inf = 1000000000;

int n, m;

vector<vector<int>> a;

int f(int curr_number)
{
    int result = 0;

    for (int i = 1; i < n; ++i)
    {
        auto it = lower_bound(a[i].begin(), a[i].end(), curr_number);

        int diff = inf;
        int res = inf;

        if (it != a[i].end())
        {
            if (diff > abs(*it - curr_number))
            {
                diff = abs(*it - curr_number);
                res = *it;
            }
        }

        if (it != a[i].begin())
        {
            --it;

            if (diff > abs(*it - curr_number))
            {
                diff = abs(*it - curr_number);
                res = *it;
            }
        }

        result = max(result, diff);

        curr_number = res;
    }

    return result;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m;

    a.resize(n);

    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            int x;
            cin >> x;
            a[i].push_back(x);
        }
    }

    if (n == 1)
    {
        cout << 0 << endl;
        return 0;
    }

    for (int i = 0; i < n; ++i)
    {
        sort(a[i].begin(), a[i].end());
    }

    int ans = inf;

    for (int i = 0; i < m; ++i)
    {
        ans = min(ans, f(a[0][i]));

        //cout << a[0][i] << " -> " << f(a[0][i]) << endl;
    }

    cout << ans << endl;

    return 0;
}
