#include <bits/stdc++.h>

using namespace std;

const int inf = 1000000000;

int n, m;

vector<vector<int>> a;

int f(int id, int curr_number)
{
    if (id == n)
    {
        return 0;
    }

    auto it = lower_bound(a[id].begin(), a[id].end(), curr_number);

    int diff = inf;
    int opt1 = inf;
    int opt2 = inf;
    bool flag1 = false;
    bool flag = false;

    if (it != a[id].end())
    {
        if (diff > abs(*it - curr_number))
        {
            diff = abs(*it - curr_number);
            opt1 = *it;
        }
    }

    if (it != a[id].begin())
    {
        --it;

        if (diff > abs(*it - curr_number))
        {
            flag1 = true;
            diff = abs(*it - curr_number);
            opt2 = *it;
        }
        else if (diff == abs(*it - curr_number))
        {
            flag = true;
            opt2 = *it;
        }
    }

    int ans = 0;

    if (flag1 == false && flag == false)
    {
        ans = max(ans, max(diff, f(id + 1, opt1)));
    }
    else if (flag == false && flag1 == true)
    {
        ans = max(ans, max(diff, f(id + 1, opt2)));
    }
    else
    {
        int ans1 = max(diff, f(id + 1, opt1));
        int ans2 = max(diff, f(id + 1, opt2));
        ans = min(ans1, ans2);
    }

    return ans;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m;

    a.resize(n);

    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            int x;
            cin >> x;
            a[i].push_back(x);
        }
    }

    if (n == 1)
    {
        cout << 0 << endl;
        return 0;
    }

    for (int i = 0; i < n; ++i)
    {
        sort(a[i].begin(), a[i].end());
    }

    int ans = inf;

    for (int i = 0; i < m; ++i)
    {
        ans = min(ans, f(1, a[0][i]));

        //cout << a[0][i] << " -> " << f(a[0][i]) << endl;
    }

    cout << ans << endl;

    return 0;
}
