#include <bits/stdc++.h>

using namespace std;

const int inf = 1000000000;

int n, m;

vector<vector<int>> a;

vector<vector<int>> dp;

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m;

    a.resize(n);

    dp.resize(n);

    for (int i = 0; i < m; ++i)
    {
        dp[0].push_back(0);
    }

    for (int i = 1; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            dp[i].push_back(inf);
        }
    }

    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            int x;
            cin >> x;
            a[i].push_back(x);
        }
    }

    if (n == 1)
    {
        cout << 0 << endl;
        return 0;
    }

    for (int i = 1; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            for (int k = 0; k < m; ++k)
            {
                dp[i][j] = min(dp[i][j], max(abs(a[i][j] - a[i - 1][k]), dp[i - 1][k]));
            }
        }
    }

    int ans = inf;

    for (int i = 0; i < m; ++i)
    {
        ans = min(ans, dp[n - 1][i]);
    }

    cout << ans << endl;

    return 0;
}
