#include<bits/stdc++.h>
using namespace std;

#define endl "\n"

const long long MAX_N = 1e5 + 5;
const long long INF = 1e8 + 99;

int n, m;
int c[MAX_N];
vector <int> susediNa[MAX_N];

vector <int> comp[MAX_N];
int componenta[MAX_N];

int compMin[MAX_N];
int compMax[MAX_N];

int compCount = 0;

bool isSubtask1 = false;

void bfs (int start, int cmp) {
    comp[cmp].push_back(start);
    compMin[cmp] = c[start];
    compMax[cmp] = c[start];

    queue <int> current;
    current.push(start);
    componenta[start] = cmp;

    while (!current.empty()) {
        int curr = current.front();
        current.pop();
        for (int i = 0; i < susediNa[curr].size(); i ++) {
            if (componenta[susediNa[curr][i]] != -1) continue;
            current.push(susediNa[curr][i]);
            componenta[susediNa[curr][i]] = cmp;
            comp[cmp].push_back(susediNa[curr][i]);
            compMin[cmp] = min(compMin[cmp], c[susediNa[curr][i]]);
            compMax[cmp] = max(compMax[cmp], c[susediNa[curr][i]]);
        }
    }
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);



    for (int i = 0; i < MAX_N; i ++) {
        componenta[i] = -1;
    }

    cin >> n >> m;

    isSubtask1 = true;

    for (int i = 0; i < n; i ++) {
        cin >> c[i];
        if (i != c[i]) isSubtask1 = false;
    }

    for (int i = 0; i < m; i ++) {
        int a, b;
        cin >> a >> b;
        a --;
        b --;
        susediNa[a].push_back(b);
        susediNa[b].push_back(a);
    }

    for (int i = 0; i < n; i ++) {
        if (componenta[i] != -1) continue;

        bfs(i, compCount);
        compCount ++;
    }
    /*
    for (int i = 0; i < n; i ++) {
        cout << i << " - " << componenta[i] << endl;
    }

    for (int i = 0; i < compCount; i ++) {
        cout << i << ". ";
        for (int j = 0; j < comp[i].size(); j ++) {
            cout << comp[i][j] << " ";
        }
        cout << endl;
    }
*/
    if (isSubtask1) {
        long long ans = 0;
        for (int i = 0; i < n - 1; i ++) {
            if (componenta[i] != componenta[i + 1]) {
                ans ++;
                //cout << i << " " << i + 1 << " " << componenta[i] << " " << componenta[i + 1] << endl;
                for (int j = 0; j < comp[componenta[i + 1]].size(); j ++) {
                    //cout << "\t" << componenta[i + 1] << " " << comp[componenta[i + 1]].size() << " " << comp[componenta[i + 1]][j] << " -> " << componenta[i] << endl;
                    if (comp[componenta[i + 1]][j] != i + 1) componenta[comp[componenta[i + 1]][j]] = componenta[i];
                }
            }
            componenta[i + 1] = componenta[i];
        }

        cout << ans << endl;
    } else {
        long long cSize2 = compCount, ans = 0;
        while (cSize2 > 1) {
            long long bm1ind = 0, bm2ind = 1, bmValue = INF;
            for (int i = 0; i < compCount; i ++) {
                for (int j = i + 1; j < compCount; j ++) {
                    for (int c1 = 0; c1 < comp[i].size(); c1 ++) {
                        for (int c2 = 0; c2 < comp[j].size(); c2 ++) {
                            if (bmValue > abs(c[comp[i][c1]] - c[comp[j][c2]])) {
                                bmValue = abs(c[comp[i][c1]] - c[comp[j][c2]]);
                                bm1ind = i;
                                bm2ind = j;
                            }
                        }
                    }
                }
            }
            cout << cSize2 << " " << bmValue << endl;
            ans += bmValue;

            if (comp[bm1ind].size() < comp[bm2ind].size()) {
                while (comp[bm1ind].size() > 0) {
                    comp[bm2ind].push_back(comp[bm1ind].back());
                    comp[bm1ind].pop_back();
                }
            } else {
                while (comp[bm2ind].size() > 0) {
                    comp[bm1ind].push_back(comp[bm2ind].back());
                    comp[bm2ind].pop_back();
                }
            }

            cSize2 --;
        }
        cout << ans << endl;
    }
    return 0;
}
