#include<bits/stdc++.h>
using namespace std;
#define endl "\n"

const long long MAX_N = 1e5;
const long long MAX_M = 500;
const long long INF = 1e8 + 10;
int n, m;
int a[MAX_N][MAX_M];

bool isIn (int i) {
    return i >= 0 && i < m;
}

int binary (int row, int x) {
    int l = 0, r = m - 1, mid = (l + r) / 2;
    int ans = -1;
    while (l <= r) {
        mid = (l + r) / 2;
        if (a[row][mid] <= x) {
            ans = mid;
            l = mid + 1;
        } else {
            r = mid - 1;
        }
    }
    return ans;
}

int solve (int row, int col, int ans) {
    if (row == n - 1) return ans;
    int ind = binary(row + 1, a[row][col]);
    //cout << row << " " << col << " binary(" << row + 1 << ", " << a[row][col] << ") = " << ind << endl;
    int closest = INF, clInd = 0;
    if (isIn(ind)) {
        if(closest > abs(a[row][col] - a[row + 1][ind])) {
            clInd = ind;
            closest = abs(a[row][col] - a[row + 1][ind]);
        }
    }
    if (isIn(ind + 1)) {
        if (closest > abs(a[row][col] - a[row + 1][ind + 1])) {
            closest = abs(a[row][col] - a[row + 1][ind + 1]);
            clInd = ind + 1;
        }
    }
    return solve(row + 1, clInd, max(closest, ans));
}
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> m;

    for (int i = 0; i < n; i ++) {
        for (int j = 0; j < m; j ++) {
            cin >> a[i][j];
        }

        sort (a[i], a[i] + m);
    }
    /*
    cout << endl;
    for (int i = 0; i < n ; i ++) {
        for  (int j = 0; j < m ; j ++) {
            cout << a[i][j] << " ";
        }

        cout << endl;
    }
    cout << endl;
    */
    int ans = solve(0, 0, 0);
    for (int i = 0; i < m; i ++) {
        //cout << solve(0, i, 0) << endl;
        ans = min(ans, solve (0, i, 0));
    }

    cout << ans << endl;


    return 0;
}

