#include <bits/stdc++.h>
using namespace std;

const int MAX_N=1e5+1;
int N, M;
int H[MAX_N];
set<int> edges[MAX_N], comp_edges[MAX_N];
int components[MAX_N];
bool visited[MAX_N];
vector<int> components_set;

void dfs(int u, int component)
{
    if(visited[u])
    {
        return;
    }

    components[u]=component;
    visited[u]=true;
    comp_edges[component].insert(u);

    for(auto& v:edges[u])
    {
        dfs(v, component);
    }
}



int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> N >> M;

    for(int i=1; i<=N; i++)
    {
        cin >> H[i];
    }

    for(int i=0; i<M; i++)
    {
        int u, v;
        cin >> u >> v;
        edges[u].insert(v);
        edges[v].insert(u);
    }

    for(int i=1; i<=N; i++)
    {
        if(visited[i])
        {
            continue;
        }

        dfs(i, i);
        components_set.push_back(i);
    }

    cout << components_set.size()-1;

    return 0;
}
