#include <bits/stdc++.h>
#include <iostream>
using namespace std;

int h[100000];
//vector<int> p[1000000];
vector<int> s[100000];
vector<pair<int, int>> group[100000];
int belongsToGroup[100000];
int o = 0;///obhodeni
vector<pair<pair<int, int>, int>> rebro;
vector<int> connected;

queue<int> q;

void maj_e_dfs(int groupNum, int st_hill) {
    q.push(st_hill);

    while (!q.empty()) {
        int temp = q.front();
        q.pop();
        if (belongsToGroup[temp] != 0) {
            continue;
        }
        belongsToGroup[temp] = groupNum;
        group[groupNum].push_back(make_pair(h[temp],temp));
        o++;

        for (int i = 0; i < s[temp].size(); i++) {
            q.push(s[temp][i]);
        }
    }
}

int cal_rebro(vector<pair<int, int>> a, vector<pair<int, int>> b) {
    int a_it = 0, b_it = 0, min_rebro = INT_MAX;
    while (a_it < a.size() && b_it < b.size()) {
        min_rebro = min(min_rebro, abs(a[a_it].first - b[b_it].first));
        if (a[a_it].first < b[b_it].first) {
            a_it++;
        } else {
            b_it++;
        }
    }
    return min_rebro;
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, min_h = INT_MAX, max_h =0;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> h[i];
        min_h = min(min_h, h[i]);
        max_h = max(max_h, h[i]);
    }
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        s[a - 1].push_back(b - 1);
        s[b - 1].push_back(a - 1);
    }

    int groupsNum = 0;
    for (int i = 0; i < n && o < n; i++) {
        if (belongsToGroup[i] == 0) {
            maj_e_dfs(groupsNum +1, i);
            groupsNum++;
        }
    }

    sort(group, group + int(1e5));
    for (int i = 0; i < (int)(1e5); i++) {
        if (group[i].size() != 0) {
            sort(group[i].begin(), group[i].end());
        }
    }

    for (int i = 0; i < (int)(1e5); i++) {
        for (int q = 0; q < (int)(1e5); q++) {
            if (group[i].size() != 0) {
                int minRebroRes = cal_rebro(group[i], group[q]);
                rebro.push_back(make_pair(make_pair(belongsToGroup[group[i][0].second], belongsToGroup[group[q][0].second]), minRebroRes));
            }
        }
    }

    int ans = 0;
    sort(rebro.begin(), rebro.end());
    for (int i = 0; i < rebro.size(); i++) {
        connected.push_back(rebro[i].first.first);
        connected.push_back(rebro[i].first.second);
        ans += rebro[i].second;

        for (int j  = 0; j < connected.size(); j++) {
            for (int q  = 0; q < connected.size(); q++) {
                for (int x  = 0; x < rebro.size(); x++) {
                    if(rebro[x].first.first == connected[j] && rebro[x].first.second == connected[q]) {
                        rebro.erase(rebro.begin() + x);
                        break;
                    }
                    if(rebro[x].first.second == connected[j] && rebro[x].first.first == connected[q]) {
                        rebro.erase(rebro.begin() + x);
                        break;
                    }
                }
            }
        }
    }
    cout << ans;
}
