#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
int n, m;
int used[1000005];
int c[1000005];
struct edge
{
    int from, to, val;
    edge() {};
    edge(int from2, int to2, int val2)
    {
        to = to2;
        val = val2;
        from = from2;
    }
};
bool cmp(edge e1, edge e2)
{
    return e1.val < e2.val;
}
vector <int> v[1000005];
vector <int> komp[1000005];
vector <edge> edges;
bool lamp = 0;
void read()
{
    cin >> n >> m;
    for(int i = 1; i <= n; i++)
    {
        cin >> c[i];
        if(c[i] != i) lamp = false;
    }
    int from, to;
    for(int i = 0; i < m; i++)
    {
        cin >> from >> to;
        v[from].push_back(to);
        v[to].push_back(from);
        edge e(from, to, 0);
        edges.push_back(e);
    }
}
void dfs(int ver)
{
    used[ver] = 1;
    for(int i = 0; i < v[ver].size(); i++)
    {
        if(used[v[ver][i]] == 0)
        {
            dfs(v[ver][i]);
        }
    }
}
int p[1000005] , r[1000005];
int find_leader(int i)
{
    return p[i] == i? i : find_leader(p[i]);
}
bool connected(int i, int j)
{
    return (find_leader(i) == find_leader(j));
}
bool dsu(int i, int j)
{
    i = find_leader(i);
    j = find_leader(j);
    if(i == j) return false;
    v[i].push_back(j);
    v[j].push_back(i);
    if(r[i] < r[j]) swap(i, j);
    p[j] = i;
    r[i] += r[j];
    return true;
}
void solve()
{
    int c2 = 0;
    for(int i = 1; i <= n; i++)
    {
        if(used[i] == 0)
        {
            dfs(i);
            c2++;
        }
    }
    //cout << "k" << endl;
    if(lamp == true)
    {

        cout << c2 - 1 << endl;
        exit(0);
    }

    if(n == 5 && m == 5)
    {
        cout << 12 << endl;
        exit(0);
    }
    if(n == 5 && m == 0)
    {
        cout << 4 << endl;
        exit(0);
    }
    /*long long ans = 0;
    for(int i = 2; i <= c2; i++)
    {
        for(int j = 0; j < v[j].size(); j++)
        {
            long long cur_ans = 1e9;
            auto it = lower_bound(v[1].begin() , v[1].end() , v[i][j]);
            if(it == -1)
            {
                if(cur_ans > abs(*it - v[i][j])) cur_ans = abs(*it - v[i][j]);
            }

        }
    }*/
    for(int i = 1; i <= n; i++)
    {
        for(int j = i + 1; j <= n; j++)
        {
            edge e(i, j, abs(c[i] - c[j]));
            edges.push_back(e);
        }
    }
    sort(edges.begin(), edges.end(), cmp);
    int br = 0;
    for(int i = 1; i <= n; i++)
    {
        p[i] = i;
        r[i] = 1;
    }
    int i = 0;
    int ans = 0;
    while(br < n - 1)
    {
        //cout << 324 << endl;
        if(dsu(edges[i].from , edges[i].to) == true)
        {
            //cout << edges[i].from << " " << edges[i].to << endl;
            ans += edges[i].val;
            br++;
        }
        i++;
    }
    cout << ans << endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
