#include <bits/stdc++.h>

using namespace std;

struct Point
{
    long long a,b,dist;
    Point(){};
    Point(long long ai, long long bi, long long di)
    {
        a = ai;
        b = bi;
        dist = di;
    }
};

const int maxn = 1e5+5;
int n,m;
long long c[maxn];
int lead[maxn],br[maxn];
int brk;
long long minraz;
vector<Point>sp;
//vector<edge>v;

void pre()
{
    //cout << "NESHTO" << endl;
    brk = n;
    for(int i=1;i<=n;i++)
    {
        lead[i] = i;
        br[i] = 1;
    }
    /*for(int i=1;i<=n;i++)
    {
        cout << lead[i] << " ";
    }
    cout << endl;*/
}

int find_lead(int x)
{
    if(x==lead[x]) return x;
    return lead[x] = find_lead(lead[x]);
}

void read()
{
    cin >> n >> m;
    pre();
    for(int i=1;i<=n;i++)
    {
        cin >> c[i];
    }
    int x,y;
    for(int i=1;i<=m;i++)
    {
        cin >> x >> y;
        x = find_lead(x);
        y = find_lead(y);
        if(x!=y)
        {
            brk--;
            if(br[x]<br[y])
            {
                br[y] += br[x];
                lead[x] = y;
            }
            else
            {
                br[x] += br[y];
                lead[y] = x;
            }
        }
    }
    /*for(int i=1;i<=n;i++)
    {
        cout << lead[i] << " ";
    }
    cout << endl;*/
}

void make_sp()
{
    for(int i=1;i<=n;i++)
    {
        for(int j=i+1;j<=n;j++)
        {
            sp.push_back({i,j,abs(c[i]-c[j])});
        }
    }
}

bool cmp(Point p1, Point p2)
{
    return p1.dist<p2.dist;
}

void solve()
{
    make_sp();
    sort(sp.begin(),sp.end(),cmp);
    int x,y;
    for(int i=0;i<sp.size();i++)
    {
        //cout << brk << endl;
        if(brk==1) break;
        x = sp[i].a;
        y = sp[i].b;
        x = find_lead(x);
        y = find_lead(y);
        if(x!=y)
        {
            brk--;
            minraz += sp[i].dist;
            if(br[x]<br[y])
            {
                br[y] += br[x];
                lead[x] = y;
            }
            else
            {
                br[x] += br[y];
                lead[y] = x;
            }
        }
    }
    cout << minraz << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
