#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e5 + 10;
int n, m, leader[maxn], c[maxn];
vector<int> g[maxn], comp[maxn];
set<int> s[maxn];

int find_leader(int x){
    if(leader[x] == x)
        return x;
    return leader[x] = find_leader(leader[x]);
}

long long cost;
struct edge{
    int a, b, c;
};
vector<edge> v;

void unite(edge e){
    int lx = find_leader(e.a);
    int ly = find_leader(e.b);
    if(lx != ly){
        leader[lx] = ly;
        cost += e.c;
    }
}

bool cmp(edge e1, edge e2){
    return e1.c < e2.c;
}

void read(){
    cin >> n >> m;
    for(int i = 1;i <= n;i++){
        cin >> c[i];
        leader[i] = i;
    }
    for(int i = 1;i <= m;i++){
        int a, b;
        cin >> a >> b;
        v.push_back({a, b, 0});
    }
}

void solve(){
    for(edge e : v)
        unite(e);
    for(int i = 1;i < n;i++){
        unite({i, i + 1, 1});
    }
    cout << cost << endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
