#include<bits/stdc++.h>
using namespace std;
struct edge
{
    int x,y,d;
    edge(){}
    edge(int _x,int _y,int _d)
    {
        x=_x;
        y=_y;
        d=_d;
    }
    bool operator<(const edge e)const
    {
        return e.d<d;
    }
};
int n,m,c[100001];
priority_queue<edge> q;
int p[100001],sz[100001],ans;
int findpar(int x)
{
    if(x==p[x])return x;
    return p[x]=findpar(p[x]);
}
void unite(int x,int y,int d)
{
    int p1=findpar(x);
    int p2=findpar(y);
    if(p1!=p2)
    {
        if(sz[p1]>sz[p2])swap(p1,p2);
        p[p1]=p2;
        sz[p2]+=sz[p1];
        ans+=d;
    }
}
void read()
{
    cin>>n>>m;
    for(int i=1;i<=n;i++)
    {
        cin>>c[i];
        p[i]=i;
        sz[i]=1;
    }
    for(int i=1;i<=m;i++)
    {
        int a,b;
        cin>>a>>b;
        unite(a,b,0);
    }
}
void solve()
{
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            if(i!=j)q.push({i,j,abs(c[i]-c[j])});
        }
    }
    while(!q.empty())
    {
        edge t=q.top();
        q.pop();
        unite(t.x,t.y,t.d);
    }
    cout<<ans<<endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
